typeset extension=""
typeset mailto=""
typeset encoder=""
+typeset ripper=""
typeset default_alang="en"
typeset track=""
typeset drc="0.0"
typeset -i custom_audio_6ch=0
typeset -i minimum_feature_title_length=60
typeset -i lsdvd_timeout=10
-typeset -i real_isofile=0
##############################################################################
# Local Machine Settings:
##############################################################################################
# Command line processing
##############################################################################################
-while (($#)) && getopts 162wmvifkzx:ht:n:d:b:B:s:t:a:p:e:j:l:r: opt "$@"
+while (($#)) && getopts 162wmvifkzx:ht:n:d:b:B:s:t:a:p:e:j:l:r:R: opt "$@"
do
case $opt in
(n) dvdname=$OPTARG;;
(i) make_final_dest_iso=1;;
(f) make_final_dest_folder=1;;
(z) make_final_dest_comp=1;;
+ (R) ripper=$OPTARG;;
(e) encoder=$OPTARG;;
(m) mirror_mode=1;;
(k) keep_intermediate_files=1;;
echo >&2 " - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
echo >&2 " - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
echo >&2 " Handbrake Only Encoder Profiles:"
- echo >&2 " - mkvvhq = MKV, very high quality encoding (0.90 quality) (requires makemkv encoder option)"
- echo >&2 " - mkvhq = MKV, high quality encoding (0.85 quality) (requires makemkv encoder option)"
+ echo >&2 " - mkvvhq = MKV, very high quality encoding (0.95 quality)"
+ echo >&2 " - mkvhq = MKV, high quality encoding (0.90 quality)"
+ echo >&2 " - mkv = MKV, high quality encoding (0.85 quality)"
echo >&2 " - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
echo >&2 " - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
echo >&2 " - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
echo >&2 " -v Make the final image a DVD VOB file"
echo >&2 " -i Make the final image a DVD ISO file"
echo >&2 " -f Make the final image a DVD folder"
- echo >&2 " -z Make the final image a compressed file based on your profile selection and encoder"
- echo >&2 " -e <encoder> Specify the encoder to use to make the compressed file (valid encoders=mencoder|handbrake|makemkv) (default=handbrake if found)"
+ echo >&2 " -z Make the final image a compressed fi[[ ! -e "$vobfile" ]]le based on your profile selection and encoder"
+ echo >&2 " -R <ripper> Specify the ripper to use to make the DVD image (valid rippers=ddrescue|makemkv|handbrake|mplayer) (default=makemkv if found)"
+ echo >&2 " -e <encoder> Specify the encoder to use to make the compressed file (valid encoders=mencoder|handbrake) (default=handbrake if found)"
echo >&2 " You must also specify the target size or bitrate using the '-s' or '-b' options with xvid profiles"
echo >&2 " -s <size> Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
echo >&2 " -b <bitrate> Set the video bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"
custom_audio_6ch=1
fi
+# Make makemkv the default ripper if not specified and we can find it
+if [ -z "$ripper" ]; then
+ ripper="makemkv"
+ [[ ! -x `which $makemkv` ]] && ripper="ddrescue";
+fi
+
# Make handbrake the default encoder if not specified and we can find it
if [ -z "$encoder" ]; then
- encoder="mencoder"; # If we can't find handbrake or makemkv, set mencoder as the default
+ encoder="mencoder"; # If we can't find handbrake, set mencoder as the default
[[ -x `which $handbrake_xvid` ]] && [[ "$profile" =~ "xvid" ]] && encoder="handbrake";
[[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "mp4" ]] && encoder="handbrake";
+ [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "mk4" ]] && encoder="handbrake";
[[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "ip" ]] && encoder="handbrake";
[[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "hb" ]] && encoder="handbrake";
- [[ -x `which $makemkv` ]] && [[ "$profile" =~ "mkv" ]] && encoder="makemkv";
fi
# Sanity check the profile selection
[[ "$profile" =~ "mp4" ]] && echo "-E- invalid encoder $encoder selected for mp4 profile: $profile" && exit
[[ "$profile" =~ "mkv" ]] && echo "-E- invalid encoder $encoder selected for mkv profile: $profile" && exit
fi
-if [[ "$encoder" == "handbrake" ]]; then
- [[ "$profile" =~ "mkv" ]] && echo "-E- invalid encoder $encoder selected for mkv profile: $profile" && exit
-fi
-if [[ "$encoder" != "mencoder" ]] && [[ "$encoder" != "handbrake" ]] && [[ "$encoder" != "makemkv" ]]; then
+if [[ "$encoder" != "mencoder" ]] && [[ "$encoder" != "handbrake" ]]; then
echo "-E- Invalid encoder specified: $encoder"
exit 1
fi
[[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
[[ -n "$handbrake_xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing handbrake xvid encoder, set in rip_dvd.conf to: $handbrake_xvid" && exit
[[ -n "$handbrake_mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing handbrake mp4 encoder, set in rip_dvd.conf to: $handbrake_mp4" && exit
-[[ -n "$makemkv" ]] && [[ ! -x `which $makemkv` ]] && echo "-E- missing makemkv encoder, set in rip_dvd.conf to: $makemkv" && exit
+[[ -n "$makemkv" ]] && [[ ! -x `which $makemkv` ]] && echo "-E- missing makemkv ripper, set in rip_dvd.conf to: $makemkv" && exit
[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing HandBrake encoder: $handbrake_xvid" && exit
[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing HandBrake encoder: $handbrake_mp4" && exit
[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "ip" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing HandBrake encoder: $handbrake_mp4" && exit
[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "hb" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing HandBrake encoder: $handbrake_mp4" && exit
-[[ "$encoder" == "makemkv" ]] && [[ "$profile" =~ "mkv" ]] && [[ ! -x `which $makemkv` ]] && echo "-E- missing MakeMKV encoder: $makemkv" && exit
-[[ "$encoder" == "makemkv" ]] && [[ "$profile" =~ "mkv" ]] && [[ ! -x `which $mkvextract` ]] && echo "-E- missing mkvextract: $mkvextract" && exit
-[[ "$encoder" == "makemkv" ]] && [[ "$profile" =~ "mkv" ]] && [[ ! -x `which $mkvpropedit` ]] && echo "-E- missing mkvpropedit: $mkvpropedit" && exit
-[[ "$encoder" == "makemkv" ]] && [[ "$profile" =~ "mkv" ]] && [[ ! -x `which $mkvmerge` ]] && echo "-E- missing mkvmerge: $mkvmerge" && exit
+[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mkv" ]] && [[ ! -x `which $mkvextract` ]] && echo "-E- missing mkvextract: $mkvextract" && exit
+[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mkv" ]] && [[ ! -x `which $mkvpropedit` ]] && echo "-E- missing mkvpropedit: $mkvpropedit" && exit
+[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mkv" ]] && [[ ! -x `which $mkvmerge` ]] && echo "-E- missing mkvmerge: $mkvmerge" && exit
[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mp4" ]] && [[ ! -x `which $mp4box` ]] && echo "-E- missing mp4box: $mp4box" && exit
[[ "$encoder" == "handbrake" ]] && [[ ! -x `which ffmpeg` ]] && echo "-E- missing dependency: ffmpeg" && exit
file "$dvdname" | grep -q "MPEG"
if [ $? == 0 ]; then
# It is a valid MPEG2 file, now strip the extension off our dvdname
+ # An MPEG file is like a VOB file (intermediate format of the DVD movie)
vobfile="$dvdname"
dvdname=`basename "$dvdname"`
dvdname=${dvdname%.[^.]*}
file "$dvdname" | grep -q -e "ISO" -e "UDF"
if [ $? == 0 ]; then
# It is a valid ISO file, now strip the extension off our dvdname
+ # An ISO file is treated as a disc or DVD image that needs to be converted
+ # to an intermediate vobfile before it can be compressed.
isofile="$dvdname"
dvdname=`basename "$dvdname"`
dvdname=${dvdname%.[^.]*}
keep_isofile=1
valid_file=1
- real_isofile=1
fi
- # check to see if dvdname is a full path to an ISO file
+ # check to see if dvdname is a full path to a VOB file
# if it is, set dvdname and isofile appropriately
file "$dvdname" | grep -q -e "VOB"
if [ $? == 0 ]; then
# It is a valid VOB file, now strip the extension off our dvdname
+ # A VOB file is an intermediate format of the DVD movie
vobfile="$dvdname"
dvdname=`basename "$dvdname"`
dvdname=${dvdname%.[^.]*}
valid_file=1
fi
- # check to see if dvdname is a full path to an ISO file
+ # check to see if dvdname is a full path to an MKV file
# if it is, set dvdname and isofile appropriately
file "$dvdname" | grep -q -e "mkv"
if [ $? == 0 ]; then
- # It is a valid VOB file, now strip the extension off our dvdname
- isofile="$dvdname"
+ # It is a valid MKV file, now strip the extension off our dvdname
+ # An MKV file is like a VOB file (intermediate format of the DVD movie)
+ vobfile="$dvdname"
dvdname=`basename "$dvdname"`
dvdname=${dvdname%.[^.]*}
- keep_isofile=1
+ keep_vobfile=1
valid_file=1
fi
# Set a variable that we will use later to determine if we found a handler for $profile or not
typeset -i found_profile=0
- # For a given profile, to override the 2 pass behavior to be single pass,
- # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler.
- # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
+ # Default is 2 pass mode. Profiles can override this. Command line can override this as well.
PASSES="-2"
+ if [ $force_onepass_mode -eq 1 ]; then
+ PASSES=""
+ fi
# Set our DRC option
DRC="-D $drc"
PASSES=""
fi
- # get our audio track from the VOB file (requires mp4 version of handbrake to extract)
- get_audio_track_from_vob "$vobfile" "$handbrake_mp4"
+ # get our audio track from the vobfile (requires mp4 version of handbrake to extract)
+ if [[ "$vobfile" =~ /mkv/ ]]; then
+ get_subtitle_track_from_mkv "$vobfile" "$handbrake_mp4"
+ else
+ get_audio_track_from_vob "$vobfile" "$handbrake_mp4"
+ fi
# XVID profile
if [[ "$profile" =~ "xvid" ]]; then
found_profile=1
handbrake_cli="$handbrake_mp4"
final_output_file="$dest/$dvdname.mp4"
- PASSES=""
+ PASSES="$PASSES -T"
# Handle custom parameter overrides
if [ $custom_video_bitrate == 1 ]; then
fi
fi
+ # MKV profile
+ if [[ "$profile" =~ "mkv" ]]; then
+ found_profile=1
+ handbrake_cli="$handbrake_mp4"
+ final_output_file="$dest/$dvdname.mkv"
+ PASSES=""
+
+ # Handle custom parameter overrides
+ if [ $custom_video_bitrate == 1 ]; then
+ handbrake_opts[0]="-b $target_video_bitrate"
+ fi
+ if [ $custom_audio_2ch == 0 ]; then
+ audio_2ch=0
+ fi
+ if [ $custom_audio_6ch == 0 ]; then
+ audio_6ch=0
+ fi
+
+ # Very High Quality
+ if [ "$profile" == "mkvvhq" ]; then
+ handbrake_opts[0]="-q 0.95"
+ fi
+ # High Quality
+ if [ "$profile" == "mkvhq" ]; then
+ handbrake_opts[0]="-q 0.90"
+ fi
+ # Fast
+ if [ "$profile" == "mkv" ]; then
+ handbrake_opts[0]="-q 0.85"
+ fi
+
+ # Common options to all profiles above
+ handbrake_opts[1]="--strict-anamorphic"
+ handbrake_opts[2]="--crop 0:0:0:0"
+
+ fi
+
# iphone and ipod MP4 profiles
if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
found_profile=1
found_profile=1
handbrake_cli="$handbrake_mp4"
final_output_file="$dest/$dvdname.mp4"
- PASSES=""
# Handle custom parameter overrides
if [ $custom_video_bitrate == 1 ]; then
fatal_and_exit "-E- Unhandled handbrake error"
fi
- # Extract the chapters from the ISO/VOB so we can add them to the MP4 file. We can only do this if we have an ISO file and we made an MP4 file.
- chapter_tmpfile="$tmpdir/$dvdname.chapters"
+
+ # SRC = ISO and FINAL = MP4
+ # Extract the chapters from the ISO/VOB so we can add them to the MP4 file.
+ # We can only do this if we have an ISO file and we made an MP4 file.
if [[ "$final_output_file" =~ "mp4" ]] && [[ -e "$isofile" ]]; then
+ chapter_tmpfile="$tmpdir/$dvdname.chapters"
+ $dvdxchap -t $feature_title "$isofile" > "$chapter_tmpfile"
+ $mp4box -chap "$chapter_tmpfile" "$final_output_file"
+
+ # We could also add subtitles, but we would need to follow this guide to do it:
+ # http://ubuntuforums.org/showthread.php?t=1253635
+ # http://en.gentoo-wiki.com/wiki/Ripping_DVD_to_Matroska_and_H.264
+
+ fi
+
+ # SRC = ISO and FINAL = MKV
+ if [[ "$final_output_file" =~ "mkv" ]] && [[ -e "$isofile" ]]; then
+ chapter_tmpfile="$tmpdir/$dvdname.chapters"
$dvdxchap -t $feature_title "$isofile" > "$chapter_tmpfile"
+ $mkvpropedit -c "$chapter_tmpfile" "$final_output_file"
+ fi
+
+ # SRC = MKV and FINAL = MP4
+ if [[ "$final_output_file" =~ "mp4" ]] && [[ "$vobfile" =~ "mkv" ]]; then
+ # Extract the chapters from the src and apply to the dst
+ chapter_tmpfile="$tmpdir/$dvdname.xml"
+ $mkvextract chapters "$vobfile" > "$chapter_tmpfile"
$mp4box -chap "$chapter_tmpfile" "$final_output_file"
fi
- # We could also add subtitles, but we would need to follow this guide to do it:
- # http://ubuntuforums.org/showthread.php?t=1253635
- # http://en.gentoo-wiki.com/wiki/Ripping_DVD_to_Matroska_and_H.264
+ # SRC = MKV and FINAL = MKV
+ # If our original src file was an MKV, extract the chapters and subtitles from it
+ if [[ "$final_output_file" =~ "mkv" ]] && [[ "$vobfile" =~ "mkv" ]]; then
+ # Extract the chapters from the src and apply to the dst
+ chapter_tmpfile="$tmpdir/$dvdname.xml"
+ $mkvextract chapters "$vobfile" > "$chapter_tmpfile"
+ $mkvpropedit -c "$chapter_tmpfile" "$final_output_file"
+
+ # find out what our default_alang subtitle track is in the src
+ get_subtitle_track_from_mkv "$vobfile" "$handbrake_mp4"
+
+ # Extract the subtitles from the src and apply to the dst
+ srt_tmpfile="$tmpdir/$dvdname.srt"
+ sub_tmpfile="$tmpdir/$dvdname.sub"
+ idx_tmpfile="$tmpdir/$dvdname.idx"
+ $mkvextract tracks "$vobfile" $track:$srt_tmpfile
+ $mkvmerge -o "$final_output_file.subs" "$final_output_file" "$idx_tmpfile"
+ mv "$final_output_file.subs" "$final_output_file"
+
+ # Set the default subtitle track to "no subtitles" in the dst
+ $mkvpropedit "$final_output_file" --edit track:s1 --set flag-default=0
+ fi
# Remove intermediary file if we created one
if [ $keep_intermediate_files -eq 0 ]; then
- rm "$chapter_tmpfile"
+ [[ -e "$chapter_tmpfile" ]] && rm "$chapter_tmpfile"
+ [[ -e "$idx_tmpfile" ]] && rm "$idx_tmpfile"
+ [[ -e "$sub_tmpfile" ]] && rm "$sub_tmpfile"
else
- echo "-> Keeping intermediate chapter file: $chapter_tmpfile" | tee -a "$logfile"
+ [[ -e "$chapter_tmpfile" ]] && echo "-> Keeping intermediate chapter file: $chapter_tmpfile" | tee -a "$logfile"
+ [[ -e "$idx_tmpfile" ]] && echo "-> Keeping intermediate subtitle files: $idx_tmpfile $sub_tmpfile" | tee -a "$logfile"
fi
# Concatenate the encode log to our main log file, greping out unwanted lines
echo " If using mencoder, the target_size will be entirely disregarded." | tee -a "$logfile"
echo " You may need to rerun with the -b option with a target bitrate to get the desired size." | tee -a "$logfile"
if [[ $encoder -ne "handbrake" ]] || [[ "$profile" =~ "xvid" ]]; then
- fatal_and_exit "-E- You'll need rip this DVD with the handbrake or makemkv encoder and an MP4 type profile to get a good rip."
+ fatal_and_exit "-E- You'll need rip this DVD with the handbrake encoder and an MP4 type profile to get a good rip."
fi
fi
fi
if [[ $vob_length -lt $min_length ]]; then
if [[ $encoder -ne "handbrake" ]] || [[ "$profile" =~ "xvid" ]]; then
echo "-E- The main feature title that was ripped from the DVD has an invalid movie length." | tee -a "$logfile"
- echo " You'll need rip this DVD with the handbrake encoder and an MP4 type or makemkv encoder and an MKV type profile instead." | tee -a "$logfile"
+ echo " You'll need rip this DVD with the handbrake encoder and an MP4 or MKV type profile instead." | tee -a "$logfile"
mplayer_dumpstream_incompatibility=1
fatal_and_exit "-E- Aborting encoding step due to invalid movie length."
fi
if [ $mirror_mode -eq 1 ]; then
echo "-> Ripping DVD $dvdname to $dest"
- if [[ "$encoder" == "makemkv" ]]; then
+ if [[ "$ripper" == "makemkv" ]]; then
# use makemkv to make an MKV file of the disk
make_dvd_mkv_image "$dest/$dvdname.mkv" "disc" "$makemkv_disc_id"
# add this video data to the mythtv DB
# Rip image from DVD
if [ $ripdvd -eq 1 ]; then
echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
- if [[ "$encoder" == "makemkv" ]]; then
+ if [[ "$ripper" == "makemkv" ]]; then
# use makemkv to make an MKV file of the disk
make_dvd_mkv_image "$tmpdir/$dvdname.mkv" "disc" "$makemkv_disc_id"
+ vobfile="$tmpdir/$dvdname.mkv"
else
# use ddrescue to make an ISO image of the disk
make_dvd_iso_image "$tmpdir/$dvdname.iso"
+ isofile="$tmpdir/$dvdname.iso"
fi
fi
# Rip image from DVD path
if [ -n "$dvdpath" ]; then
echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
- if [[ "$encoder" == "makemkv" ]]; then
- make_dvd_mkv_image_from_folder "$dvdpath" "$tmpdir/$dvdname.mkv" 1
- else
- make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
- fi
- fi
-
- # make sure our isofile value is set
- if [ -z "$isofile" ]; then
- if [[ "$encoder" == "makemkv" ]]; then
- isofile="$tmpdir/$dvdname.mkv"
- else
- isofile="$tmpdir/$dvdname.iso"
- fi
- fi
-
- # MakeMKV special case
- if [[ "$encoder" == "makemkv" ]] && [[ $make_final_dest_comp -eq 1 ]]; then
- echo "-> Encoding the DVD video to a compressed file using $encoder" | tee -a "$logfile"
-
- # eject the DVD disk since we are finished with it
- [ $eject_disk -eq 2 ] && eject -T $dev
-
- # Encode the final MKV file
- encode_mkv_file_makemkv "$isofile" "$dest/$dvdname.mkv"
-
- # remove the intermediate ISO file
- remove_intermediate_iso_file
-
- # keep intermediate log files
- if [ $keep_intermediate_files -eq 0 ]; then
- [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
- else
- echo "-> Keeping mencoder 2pass logfile: $passlogfile"
- fi
-
- # add this video data to the mythtv DB
- fill_mythvideo_metadata "$dest/$dvdname.mkv"
-
- # All done!
- exit 0
+ make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
+ isofile="$tmpdir/$dvdname.iso"
fi
if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
- if [ ! -e "$vobfile" ]; then
- echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
-
- # get the feature title from the ISO
- get_feature_title "$isofile"
-
+ # Create our "vobfile" using makemkv if told to do so
+ if [[ "$isofile" =~ "iso" ]] && [[ "$ripper" == "makemkv" ]]; then
+ vobfile="$tmpdir/$dvdname.mkv"
+ make_dvd_mkv_image "$vobfile" "iso" "$isofile"
+ fi
+
+ # get the feature title from the ISO
+ if [[ "$isofile" =~ "iso" ]]; then
+ get_feature_title "$isofile"
+ fi
+
+ # Create our "vobfile" using mplayer if needed
+ if [[ ! -e "$vobfile" ]] && [[ "$isofile" =~ "iso" ]]; then
+ echo "-> Creating DVD video $vobfile from $isofile" | tee -a "$logfile"
+
# get the crop value from the ISO
get_crop_from_iso
remove_intermediate_iso_file
else
- if [ "$encoder" != "handbrake" ]; then
+ if [[ -e "$vobfile" ]] && [[ "$encoder" != "handbrake" ]]; then
echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
# get our audio id from the VOB file
get_audio_id_from_vob "$vobfile"